/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2018 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : Config_DTC_RSPI_SEND.h
* Version      : 1.5.0
* Device(s)    : R5F565NEDxFP
* Description  : This file implements device driver for Config_DTC_RSPI_SEND.
* Creation Date: 2019-07-25
***********************************************************************************************************************/

#ifndef CFG_Config_DTC_RSPI_SEND_H
#define CFG_Config_DTC_RSPI_SEND_H

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_dtc.h"

/***********************************************************************************************************************
Macro definitions (Register bit)
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro definitions
***********************************************************************************************************************/
/* DTC0 Transfer Source Address */
#define _00000000_DTC0_SRC_ADDRESS          (0x00000000UL)
/* DTC0 Transfer Destination Address */
#define _00000000_DTC0_DST_ADDRESS          (0x00000000UL)
/* DTC0 Transfer Count In Normal/Repeat Mode Or Block Size Count In Block Mode */
#define _0001_DTC0_TRANSFER_COUNT_CRA       (0x0001U)

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
void R_Config_DTC_RSPI_SEND_Create_UserInit(void);
void R_Config_DTC_RSPI_SEND_Create(void);
void R_Config_DTC_RSPI_SEND_Start(void);
void R_Config_DTC_RSPI_SEND_Stop(void);
/* Start user code for function. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#endif

